## tkey-ssh-agent 1.0.0+ds

=== Makefile ===
# Check for OS
UNAME_S := $(shell uname -s)
ifeq ($(UNAME_S),Darwin)
	shasum = shasum -a 512
	BUILD_CGO_ENABLED ?= 1
else
	shasum = sha512sum
	BUILD_CGO_ENABLED ?= 0
endif

.PHONY: all
all: tkey-ssh-agent

.PHONY: windows
windows: tkey-ssh-agent.exe tkey-ssh-agent-tray.exe

DESTDIR=/
PREFIX=/usr/local
SYSTEMDDIR=/etc/systemd
UDEVDIR=/etc/udev
destbin=$(DESTDIR)/$(PREFIX)/bin
destman1=$(DESTDIR)/$(PREFIX)/share/man/man1
destunit=$(DESTDIR)/$(SYSTEMDDIR)/user
destrules=$(DESTDIR)/$(UDEVDIR)/rules.d
.PHONY: install
install:
	install -Dm755 tkey-ssh-agent $(destbin)/tkey-ssh-agent
	strip $(destbin)/tkey-ssh-agent
	install -Dm644 system/tkey-ssh-agent.1 $(destman1)/tkey-ssh-agent.1
	gzip -n9f $(destman1)/tkey-ssh-agent.1
	install -Dm644 system/tkey-ssh-agent.service.tmpl $(destunit)/tkey-ssh-agent.service
	sed -i -e "s,##BINDIR##,$(PREFIX)/bin," $(destunit)/tkey-ssh-agent.service
	install -Dm644 system/60-tkey.rules $(destrules)/60-tkey.rules
.PHONY: uninstall
uninstall:
	rm -f \
	$(destbin)/tkey-ssh-agent \
	$(destunit)/tkey-ssh-agent.service \
	$(destrules)/60-tkey.rules \
	$(destman1)/tkey-ssh-agent.1.gz
.PHONY: reload-rules
reload-rules:
	udevadm control --reload
	udevadm trigger

.PHONY: podman
podman:
	podman run --rm --mount type=bind,source=$(CURDIR),target=/src -w /src -it ghcr.io/tillitis/tkey-builder:4 make -j

.PHONY: check-signer-hash
check-signer-hash:
	cd cmd/tkey-ssh-agent && $(shasum) -c signer.bin.sha512

TKEY_SSH_AGENT_VERSION ?=
# .PHONY to let go-build handle deps and rebuilds
.PHONY: tkey-ssh-agent
tkey-ssh-agent: check-signer-hash
	CGO_ENABLED=$(BUILD_CGO_ENABLED) go build -ldflags "-X main.version=$(TKEY_SSH_AGENT_VERSION) -X main.signerAppNoTouch=$(TKEY_SIGNER_APP_NO_TOUCH)" -trimpath -buildvcs=false ./cmd/tkey-ssh-agent

.PHONY: tkey-ssh-agent.exe
tkey-ssh-agent.exe:
	$(MAKE) -C gotools go-winres
	cd ./cmd/tkey-ssh-agent && ../../gotools/go-winres make --arch amd64
	$(MAKE) GOOS=windows GOARCH=amd64 tkey-ssh-agent

# .PHONY to let go-build handle deps and rebuilds
.PHONY: tkey-ssh-agent-tray.exe
tkey-ssh-agent-tray.exe:
	$(MAKE) -C gotools go-winres
	cd ./cmd/tkey-ssh-agent-tray && ../../gotools/go-winres make --arch amd64
	GOOS=windows GOARCH=amd64 CGO_ENABLED=0 go build -ldflags "-H windowsgui" -trimpath -buildvcs=false ./cmd/tkey-ssh-agent-tray

.PHONY: clean
clean:
	rm -f \
	tkey-ssh-agent \
	tkey-ssh-agent.exe cmd/tkey-ssh-agent/rsrc_windows_amd64.syso \
	tkey-ssh-agent-tray.exe cmd/tkey-ssh-agent-tray/rsrc_windows_amd64.syso

.PHONY: lint
lint:
	GOOS=linux   golangci-lint run
	GOOS=windows golangci-lint run

=== gotools/Makefile ===
# .PHONY to let go-build handle deps and rebuilds
.PHONY: go-winres
go-winres:
	go mod download github.com/tc-hib/go-winres
	go mod tidy
	go build github.com/tc-hib/go-winres

=== test/requirements.txt ===
pyserial==3.5

=== system/windows/Makefile ===

.PHONY: msi
msi:
	@[ -n "$$SEMVER" ] || { printf "Run like: make SEMVER=0.0.6 msi\n"; false; }
	podman run --rm -it --mount type=bind,source=$$(pwd),target=/build -w /build \
	  ghcr.io/tillitis/msi-builder:1 \
	  build-msi.sh "$$SEMVER" tkey-ssh-agent.wxs
	ls -l *.msi

.PHONY: exes
exes:
	make -C ../../ windows
	cp -af ../../tkey-ssh-agent{,-tray}.exe .

.PHONY: build-msi-builder
build-msi-builder:
	podman build -f Dockerfile -t msi-builder

.PHONY: clean
clean:
	rm -f tkey-ssh-agent{,-tray}.exe \
	  tkey-ssh-agent-*.{msi,wixpdb} tkey-ssh-agent.wixobj

=== debian/changelog ===
tkey-ssh-agent (1.0.0+ds-6) unstable; urgency=medium

  * Team upload
  * Upload to unstable

 -- Simon Josefsson <simon@josefsson.org>  Fri, 13 Feb 2026 10:24:05 +0100

tkey-ssh-agent (1.0.0+ds-5) experimental; urgency=medium

  [ Vincent Blut ]
  * Fix FTBFS with go-pinentry v4+

  [ Simon Josefsson ]
  * Drop Priority: optional
  * Standards-Version: 4.7.3
  * Drop Rules-Requires-Root: no
  * Need go-pinentry>4
  * Improve Static-Built-Using
  * Use watch v5
  * Adjust Salsa CI
  * Bump debian/* copyright years
  * Revert modification of upstream .gitignore

 -- Simon Josefsson <simon@josefsson.org>  Thu, 12 Feb 2026 17:53:15 +0100

tkey-ssh-agent (1.0.0+ds-4) unstable; urgency=medium

  * Standards-Version: 4.7.2.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 31 Mar 2025 22:15:18 +0200

tkey-ssh-agent (1.0.0+ds-3) unstable; urgency=medium

  * Bump debian/* copyright years.
  * Print SHA512 checksum of app in build logs.
  * salsa-ci: Build using official tkey-device-signer.
  * Add Static-Built-Using on tillitis-tkey-device-signer.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 03 Feb 2025 23:36:38 +0100

tkey-ssh-agent (1.0.0+ds-2) unstable; urgency=medium

  [ Simon Josefsson ]
  * Forward our pinentry patch.

  [ Michael Biebl ]
  * Move aliased files from / to /usr (DEP17). (Closes: #1088103)

 -- Simon Josefsson <simon@josefsson.org>  Thu, 28 Nov 2024 08:13:32 +0100

tkey-ssh-agent (1.0.0+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1087023)

 -- Simon Josefsson <simon@josefsson.org>  Fri, 08 Nov 2024 10:52:29 +0100

=== debian/control ===
Source: tkey-ssh-agent
Section: golang
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-spf13-pflag-dev,
 golang-github-tillitis-tkeyclient-dev,
 golang-github-tillitis-tkeysign-dev,
 golang-github-tillitis-tkeyutil-dev,
 golang-github-twpayne-go-pinentry-dev (>> 4.0.0~),
 golang-golang-x-crypto-dev,
 tillitis-tkey-device-signer,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/go-team/packages/tkey-ssh-agent
Vcs-Git: https://salsa.debian.org/go-team/packages/tkey-ssh-agent.git
Homepage: https://github.com/tillitis/tkey-ssh-agent
XS-Go-Import-Path: github.com/tillitis/tkey-ssh-agent

Package: tkey-ssh-agent
Section: admin
Architecture: any
Depends:
 tillitis-tkey-udev,
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using:
 ${misc:Built-Using},
Static-Built-Using: ${misc:Static-Built-Using},
 tillitis-tkey-device-signer (= 0.1.2-2)
Description: SSH Agent for Tillitis TKey (application)
 TKey SSH Agent - tkey-ssh-agent is an OpenSSH-compatible agent for
 use with the Tillitis (https://tillitis.se/) TKey USB security token.
 .
 This package contains the tkey-ssh-agent application.

Package: golang-github-tillitis-tkey-ssh-agent-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-spf13-pflag-dev,
 golang-golang-x-crypto-dev,
 ${misc:Depends},
Description: SSH Agent for Tillitis TKey (Go development library)
 TKey SSH Agent - tkey-ssh-agent is an OpenSSH-compatible agent for
 use with the Tillitis (https://tillitis.se/) TKey USB security token.
 .
 This package contains the Go development library.

Package: tillitis-tkey-udev
Section: admin
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Tillitis TKey udev rule
 Tillitis TKey udev rule to allow non-root users to use access the TKey.
 You will usually need this to be able to access a connected Tillitis
 (https://tillitis.se/) TKey USB security token.

=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/tillitis/tkey-ssh-agent/releases?per_page=50
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
Dversionmangle: auto
Filenamemangle: s%.*/v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%
Repacksuffix: +ds
Searchmode: plain
